package com.ann.demo.interfaces.impl;


import com.ann.demo.entity.filing.ArchiveMaster;
import com.ann.demo.interfaces.HomepageDictionary;
import com.ann.demo.service.ArchiveDetailService;
import com.ann.demo.service.ArchiveMasterService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import javax.jws.WebService;
import java.util.Arrays;
import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/6/11 17:01
 */

@WebService(serviceName = "HomepageDictionary", // 与接口中指定的name一致
        targetNamespace = "http://interfaces.demo.ann.com/", // 与接口中的命名空间一致,一般是接口的包名倒
        endpointInterface = "com.ann.demo.interfaces.HomepageDictionary"// 接口地址
)
public class HomepageDictionaryImpl implements HomepageDictionary {

    private static final Logger logger = LoggerFactory.getLogger(HomepageDictionaryImpl.class);

    @Autowired
    private ArchiveDetailService archiveDetailService;

    @Autowired
    private ArchiveMasterService archiveMasterService;

    // pdf地址
    public static String mustCheckData;

    @Value("${mustCheckData}")
    public void setMustCheckData(String mustCheckData) {
        HomepageDictionaryImpl.mustCheckData = mustCheckData;
    }

    public static String getMustCheckData() {
        return mustCheckData;
    }


    // 检验申请单号
    public static String inspectionReportType;
    @Value("${inspectionReportType}")
    public void setInspectionReportType(String inspectionReportType) {
        HomepageDictionaryImpl.inspectionReportType = inspectionReportType;
    }

    // 检查申请单号
    public static String checkReportType;
    @Value("${checkReportType}")
    public void setCheckReportType(String checkReportType) {
        HomepageDictionaryImpl.checkReportType = checkReportType;
    }

    @Override
    public String CheckData(String masterId) {
        StringBuffer sb = new StringBuffer();
        try{
            ArchiveMaster archiveMaster = archiveMasterService.findByIdAndIsValid(masterId);
            if (archiveMaster == null){
                return  "没有该患者信息！";
            }
            // 必须检查类型
            sb = new StringBuffer();
            if (!mustCheckData.equals("")) {
                String[] mustCheckDataArray = mustCheckData.split(",");
                List<String> types = Arrays.asList(mustCheckDataArray);
                String typeIsExits = archiveDetailService.getTypeNotExits(types, masterId);
                if (typeIsExits != null) {
                    sb.append(typeIsExits + "缺失");
                }
            }

            // 检查申请单
            if (!checkReportType.equals("")) {
                String[] checkReportTypeArray = checkReportType.split(",");
                List<String> types = Arrays.asList(checkReportTypeArray);
                String checkReportNotExits = archiveDetailService.getCheckReportNotExits(types, masterId);
                if (checkReportNotExits != null) {
                    if (sb.length() != 0) {
                        sb.append(";");
                    }
                    sb.append(checkReportNotExits);
                }else{
                    String typeIsExits1 =  archiveDetailService.getCheckReportNotExits1(types, masterId);
                    if (typeIsExits1 != null) {
                        if (sb.length() != 0) {
                            sb.append(";");
                        }
                        sb.append(typeIsExits1);
                    }

                }
            }
            // 检验申请单
            if (!inspectionReportType.equals("")) {
                String[] inspectionReportTypeArray = inspectionReportType.split(",");
                List<String> types = Arrays.asList(inspectionReportTypeArray);
                String checkLisNotExits = archiveDetailService.getInspectionReportNotExits1(types, masterId);
                if (checkLisNotExits != null ) {
                    if (sb.length() != 0) {
                        sb.append(";");
                    }
                    sb.append(checkLisNotExits);
                }
            }
            //最后
            if (sb.length() == 0) {
                sb.append("完整");
            }else{
                sb.append("。如开的医嘱有对应的单子，可备注给主任。");
            }
        }catch (Exception e){
            sb.setLength(0);
            sb.append("服务器正忙");
            logger.error("出错了：",e);
        }
        return sb + "";
    }
}
